#!/bin/bash

eth=$(ifconfig enp1s0 | grep ether |  awk '{print $2}')
firmware=$(cat /etc/spacemesh/version | awk -F. '{print $1}' | awk -F"-v" '{print $2}')
firmware="v"${firmware:0:1}"."${firmware:1:1}"."${firmware:2:1}
latest_firmware=$(/etc/spacemesh/get_latest_firmware.sh)
#spacemesh_version=$(grpcurl --plaintext 127.0.0.1:9092 spacemesh.v1.NodeService.Version|jq .versionString.value|awk -F'"' '{print $2}')
spacemesh_version=$(/root/Spacemesh/Linux/go-spacemesh version|awk -F+ '{print $1}')
status=$(grpcurl --plaintext 127.0.0.1:9092 spacemesh.v1.NodeService.Status)
current_height=$(echo $status|jq .status.syncedLayer.number)
latest_height=$(echo $status|jq .status.topLayer.number)
lateste_spacemesh_version=$(/etc/spacemesh/get_latest_spacemesh.sh)
wallet=$(cat /etc/spacemesh/wallet)
Smesher_ID=0x$(cat /mnt/disk0/post_data/postdata_metadata.json | jq -r '.NodeId' | base64 -d | xxd -p -c 32)


res=$(systemctl status spacemesh.service |grep Active|grep running)
res1=$(systemctl status spacemesh.service |grep Active|grep auto-restart)
if [ "$res" != "" ]
then
	spacemesh_status="Running"
elif [ "$res1" != "" ]
then
	spacemesh_status="Restarting"
else
	spacemesh_status="Dead"
fi

if [ "$spacemesh_status" = "Running" ]
then
	if [ "$current_height" = "" ];then current_height="App is loading data, please wait for several minutes";fi
	if [ "$latest_height" = "" ];then latest_height="App is loading data, please wait for several minutes";fi
fi

if [ "$wallet" = sm1qqqqqqxe4vzl0x3mnzt8g2q734k9ph72l3c2s4ct0rp6r ] || [ "$wallet" = "" ]
then
	wallet="please input your wallet"
fi

disk_flag=$(blkid|grep xfs|awk -F: '{print $1}')
if [ "$disk_flag" = "" ]
then
	diskinfo="No hard disk found"
else
	diskinfo_total=$(df -h | grep $disk_flag | awk '{print $2}')
	diskinfo_used=$(df -h | grep $disk_flag | awk '{print $3}')
	diskinfo="Total $diskinfo_total, Used $diskinfo_used"
fi

if [ "$wallet" = "please input your wallet" ] && [ "$spacemesh_status" = "Restarting" ]
then
	spacemesh_status="Dead"
fi

res=$(ps -ef|grep wget|grep /download/spacemesh/Linux)
if [ "$res" != "" ]
then
	spacemesh_version="Installing spacemesh APP, refresh later"
fi

echo -n {
echo -n \"wallet\":\"$wallet\",
echo -n \"eth\":\"$eth\",
echo -n \"diskinfo\":\"$diskinfo\",
echo -n \"Smesher_ID\":\"$Smesher_ID\",
echo -n \"spacemesh_status\":\"$spacemesh_status\",
echo -n \"spacemesh_version\":\"$spacemesh_version\",
echo -n \"latest_spacemesh_version\":\"$lateste_spacemesh_version\",
echo -n \"current_height\":\"$current_height\",
echo -n \"latest_height\":\"$latest_height\",
echo -n \"firmware\":\"$firmware\",
echo -n \"latest_firmware\":\"$latest_firmware\"
echo -n }
