#!/bin/bash

uuid=$(blkid|grep xfs|awk '{print $2}')
if [ "$uuid" = "" ]
then
 echo "no Hard disk found."
 exit
fi

wallet=$(cat /etc/spacemesh/wallet)
if [ "$wallet" = sm1qqqqqqxe4vzl0x3mnzt8g2q734k9ph72l3c2s4ct0rp6r ] || [ "$wallet" = "" ]
then
        echo "default wallet, exit"
	exit
fi


#spacemesh_version=$(grpcurl --plaintext 127.0.0.1:4092 spacemesh.v1.NodeService.Version|jq .versionString.value|awk -F'"' '{print $2}')
spacemesh_version=$(/root/Spacemesh/Linux/go-spacemesh version|awk -F+ '{print $1}')

n=1
lastaddr=""
while true
do
addr=$(cat /etc/spacemesh/server_addr|head -$n|tail -1)
if [ "$addr" != "$lastaddr" ]
then
        lastaddr=$addr;
else
        echo "no version getted"
        exit
fi
version_api_url="http://$addr/download/spacemesh/spacemesh_version"
res=$(curl -H 'Cache-Control: no-cache'  -s --connect-timeout 10 --max-time 10 $version_api_url)

version_latest=$(echo $res|jq .version|awk -F'"' '{print $2}')

if [ "$version_latest" = "" ]
then
        n=`expr $n + 1`;
else
        break
fi

done

echo current version $spacemesh_version
echo new version $version_latest

if [ "$spacemesh_version" != "$version_latest" ]
then

echo "find new version $version_latest"
cd /root/Spacemesh 
rm -rf Linux-$version_latest*
wget "http://$addr/download/spacemesh/Linux-$version_latest.zip"
systemctl stop spacemesh
rm -rf Linux
unzip Linux-$version_latest.zip 
systemctl restart spacemesh

fi
